<script lang="ts">
	import OrderForm from './entity/OrderForm';
	import { HostingType } from './types';

	import StepIndicator from './ui/StepIndicator.svelte';

	import HostingTypeWidget from './step/HostingTypeWidget.svelte';
	import ServiceTypeWidget from './step/ServiceTypeWidget.svelte';
	import TurnkeyInstanceTypeWidget from './step/turnkey/TurnkeyInstanceTypeWidget.svelte';
	import TurnkeyInstanceLocationWidget from './step/turnkey/TurnkeyInstanceLocationWidget.svelte';
	import DomainNameTypeWidget from './step/DomainNameTypeWidget.svelte';
	import TurnkeySshAccessWidget from './step/turnkey/TurnkeySshAccessWidget.svelte';
	import ByosSshAccessWidget from './step/byos/ByosSshAccessWidget.svelte';
	import ServerSizingGuideWidget from './step/ServerSizingGuideWidget.svelte';
	import ContactInfoWidget from './step/ContactInfoWidget.svelte';
	import ClientAppsWidget from './step/ClientAppsWidget.svelte';
	import BridgesWidget from './step/BridgesWidget.svelte';
	import OrderFormSchema from './validation/OrderFormSchema';

	import AdditionalServicesWidget from './step/AdditionalServicesWidget.svelte';
	import { scrollIntoView } from './utils';

	import { fade, fly } from 'svelte/transition';
	import PriceCalculator from './ui/PriceCalculator.svelte';
	import BotsWidget from './step/BotsWidget.svelte';
	import SupportTypeWidget from './step/SupportTypeWidget.svelte';

	import { additionalServices, additionalMatrixServices } from "./provider/MatrixServices";
	import { entityStore } from './utils/entityStore';

	let entity = new OrderForm();

	if (window.location.hash === '#byos') {
		entity.hostingType = HostingType.BYOS;
	}

	$entityStore = {
		hostingType: entity.hostingType,
		instanceType: entity.turnkeyInstanceTypeId
	};

	let showErrors = false;
	let errors = "";
	let isSubmitting = false;

	const submitForm = async () => {
		showErrors = false;
		errors = "";
		if (isSubmitting) {
			return;
		}

		if (entity.subdomainError) {
			errors = '<i class="fa-solid fa-circle-exclamation"></i> ' + entity.subdomainError;
			showErrors = true;
			return;
		}
		if (entity.domainNameError) {
			errors = '<i class="fa-solid fa-circle-exclamation"></i> ' + entity.domainNameError;
			showErrors = true;
			return;
		}

		try {
			OrderFormSchema.validateSync(entity, { abortEarly: false });

			const requestHeaders: HeadersInit = new Headers();
			requestHeaders.set('Content-Type', 'application/x-www-form-urlencoded;charset=UTF-8');

			const formBody = entity.toServer();
			isSubmitting = true;

			const resp = await fetch(`https://buscarron.etke.cc/orders`, {
				method: "POST",
				headers: requestHeaders,
				body: formBody
			});
			if (resp.status === 200) {
				return window.location.href = "/order/thanks"
			}
			errors = '<i class="fa-solid fa-circle-exclamation"></i> Submission failed. Please, ensure your email address is correct and <a href="/contacts/">contact us</a> for further assistance.';
			showErrors = true;
			isSubmitting = false;
		} catch (err) {
			isSubmitting = false;
			if (err.inner && err.inner.length > 0) {
				let firstErrPath = err.inner[0].path;
				const el = document.getElementsByClassName("step-" + firstErrPath)[0];
				if (el) {
					scrollIntoView(el);
				}
				errors = '<i class="fa-solid fa-circle-exclamation"></i> ' + err.errors.join('<br /> <i class="fa-solid fa-circle-exclamation"></i> ');
				showErrors = true;
			}
		}
	}

	let stepBodyClass = "ms-2 ps-4 step-body";
</script>

<p class="alert alert-warning mb-0">
	Welcome to our new ordering form, based on the <strong>pay-by-complexity pricing model</strong>!
	<br />
	In the near future, <strong>prices may increase/decrease slightly</strong>, as we're working to determine the most suitable one for each component.
</p>

<form on:submit|preventDefault={submitForm} class="my-3">
	<div class="d-flex flex-column mb-4">
		<StepIndicator stepName="hosting-type" stepTitle="Service" required={true} active={true} />

		<div class={stepBodyClass} class:step-active={true} >
			<div>
				<ServiceTypeWidget />
			</div>
		</div>
	</div>

	<div class="d-flex flex-column mb-4">
		<StepIndicator stepName="hosting-type" stepTitle="Hosting Type" required={true} active={entity.hostingType != null} />

		<div class={stepBodyClass} class:step-active={entity.hostingType != null} >
			<div>
				<HostingTypeWidget bind:value={entity.hostingType} />
			</div>

			<div>
				<h4 class="pt-0">
					<i class="fa-regular fa-lightbulb fa-lg text-secondary"></i>
					Server Sizing Guide
				</h4>

				<ServerSizingGuideWidget />
			</div>
		</div>
	</div>

	{#if entity.hostingType == HostingType.Turnkey}
		<div class="d-flex flex-column mb-4">
			<StepIndicator stepName="server-size" stepTitle="Server Size" required={true} active={entity.turnkeyInstanceTypeId != ''} />

			<div class={stepBodyClass} class:step-active={entity.turnkeyInstanceTypeId != ''}>
				<div>
					<TurnkeyInstanceTypeWidget bind:value={entity.turnkeyInstanceTypeId} />
				</div>
			</div>
		</div>

		<div class="d-flex flex-column mb-4">
			<StepIndicator stepName="server-location" stepTitle="Server Location" required={true} active={entity.turnkeyInstanceLocationId != ''} />

			<div class={stepBodyClass} class:step-active={entity.turnkeyInstanceLocationId != ''}>
				<div>
					<TurnkeyInstanceLocationWidget bind:value={entity.turnkeyInstanceLocationId} />
				</div>
			</div>
		</div>

		<div class="d-flex flex-column mb-4">
			<StepIndicator stepName="ssh-access-turnkey" stepTitle="SSH Access" active={true} />

			<div class={stepBodyClass} class:step-active={true}>
				<div>
					<TurnkeySshAccessWidget
						bind:enabled={entity.turnkeySshAccessConfig.enabled}
						bind:publicKey={entity.turnkeySshAccessConfig.publicKey}
						bind:protectSshPortWithFirewall={entity.turnkeySshAccessConfig.protectSshPortWithFirewall}
						bind:whitelistedIpAddresses={entity.turnkeySshAccessConfig.whitelistedIpAddresses}
					/>
				</div>
			</div>
		</div>
	{:else if entity.hostingType == HostingType.BYOS}
		<div class="d-flex flex-column mb-4">
			<StepIndicator stepName="ssh-access-byos" stepTitle="SSH Access" required={true} active={entity.byosSshAccessConfig.isComplete()} />

			<div class={stepBodyClass} class:step-active={entity.byosSshAccessConfig.isComplete()}>
				<div>
					<ByosSshAccessWidget
						bind:accessType={entity.byosSshAccessConfig.accessType}
						bind:portNumber={entity.byosSshAccessConfig.portNumber}
						bind:loginUsername={entity.byosSshAccessConfig.loginUsername}
						bind:hostName={entity.byosSshAccessConfig.hostName}
						bind:sudoPassword={entity.byosSshAccessConfig.sudoPassword}
						bind:publicKeyAdded={entity.byosSshAccessConfig.publicKeyAdded}
						bind:portsOpened={entity.byosSshAccessConfig.portsOpened}
						homeDirectoryPath={entity.byosSshAccessConfig.getHomeDirectoryPath()}
					/>
				</div>
			</div>
		</div>
	{/if}

	<div class="d-flex flex-column mb-4">
		<StepIndicator stepName="domain-type" stepTitle="Domain Name" required={true} active={entity.domainInfoIsComplete()} />

		<div class={stepBodyClass} class:step-active={entity.domainType != null}>
			<div>
				<DomainNameTypeWidget
					bind:domainType={entity.domainType}
					bind:fullyQualifiedDomainName={entity.fullyQualifiedDomainName}
					bind:subdomainError={entity.subdomainError}
					bind:domainNameError={entity.domainNameError}
				/>
			</div>
		</div>
	</div>

	<div class="d-flex flex-column mb-4">
		<StepIndicator stepName="contact-info" stepTitle="Contact Information" required={true} active={entity.contactInfoIsComplete()} />

		<div class={stepBodyClass} class:step-active={entity.contactInfoIsComplete()}>
			<div>
				<ContactInfoWidget bind:contactEmail={entity.contactEmail} bind:username={entity.username} domainPreview={entity.fullyQualifiedDomainName} />
			</div>
		</div>
	</div>

	<div class="d-flex flex-column mb-4">
		<StepIndicator stepName="client-apps" stepTitle="Matrix Client Apps" active={true} />

		<div class={stepBodyClass} class:step-active={true}>
			<div>
				<ClientAppsWidget bind:selectedApps={entity.selectedApps} />
			</div>
		</div>
	</div>

	<div id="matrix-bridges" class="d-flex flex-column mb-4">
		<StepIndicator stepName="bridges" stepTitle="Matrix Bridges" active={true} />

		<div class={stepBodyClass} class:step-active={true}>
			<div>
				<BridgesWidget
					bind:selectedBridges={entity.selectedBridges}
					bind:bridgeEncryptionEnabled={entity.bridgeEncryptionEnabled}
				/>
			</div>
		</div>
	</div>

	<div id="matrix-bots" class="d-flex flex-column mb-4">
		<StepIndicator stepName="bots" stepTitle="Matrix Bots" active={true} />

		<div class={stepBodyClass} class:step-active={true}>
			<div>
				<BotsWidget bind:selectedBots={entity.selectedBots} />
			</div>
		</div>
	</div>

	<div id="matrix-addons" class="d-flex flex-column mb-4">
		<StepIndicator stepName="additional-services" stepTitle="Additional Matrix services" active={true} />

		<div class={stepBodyClass} class:step-active={true}>
			<div>
				<AdditionalServicesWidget
					additionalServices={additionalMatrixServices}
					bind:selectedServices={entity.selectedMatrixServices}
				/>
			</div>
		</div>
	</div>

	<div id="non-matrix-addons" class="d-flex flex-column mb-4">
		<StepIndicator stepName="additional-services" stepTitle="Additional non-Matrix services" active={true} />

		<div class={stepBodyClass} class:step-active={true}>
			<div>
				<AdditionalServicesWidget
					additionalServices={additionalServices}
					bind:selectedServices={entity.selectedServices}
				/>
			</div>
		</div>
	</div>

	<div class="d-flex flex-column mb-4">
		<StepIndicator stepName="support-type" stepTitle="Support" required={false} active={true} />

		<div class={stepBodyClass} class:step-active={true} >
			<div>
				<SupportTypeWidget bind:value={entity.supportType} />
			</div>
		</div>
	</div>

	<div class="d-flex flex-column mb-4">
		<StepIndicator stepName="payment" stepTitle="Payment" active={true} />
		<div class={stepBodyClass} class:step-active={true}>
			Payments will have to be done on Ko-Fi via PayPal. <strong>For now, we don’t support other payment providers or methods.</strong>
			As we are not a company yet, we can't send you invoices, but you will get a PayPal receipt for any payment you make.
			<br />
			Please, keep in mind that you're ordering a subscription-based service. We do not provide one-time services,
			<a href="/help/faq/#can-i-have-one-time-setup-without-a-subscription">more details</a>.
			<br />
			We’ll ask you to pay later when your order progresses.
		</div>
	</div>

	<PriceCalculator bind:entity={entity} />

	<div class="d-flex justify-content-center">
		<button class="btn btn-outline-primary btn-lg" type="submit" disabled={isSubmitting}>{isSubmitting ? "Submitting..." : "Submit Order"}</button>
	</div>
	{#if showErrors}
		<div class="form-errors rounded shadow" in:fly="{{ y: 200, duration: 1000 }}" out:fade>
			<button class="btn btn-outline-primary bg-danger text-light d-flex align-self-end mb-2" on:click|preventDefault={() => {
				showErrors = false;
			}}>
				X
			</button>
			<div class="errors-container">{@html errors}</div>
		</div>
	{/if}
</form>

<style>
	.form-errors {
		position: fixed;
		z-index: 10;
		top: 50%;
		right: 90px;
		display: flex;
		flex-direction: column;
		margin-top: 1rem;
		background: rgb(207, 98, 98);
		color: #fff;
		padding: 0.75rem 1.5rem;
	}

	.errors-container {
		font-size: 1.1rem;
	}
</style>
